package nakov1_4;

import java.net.*;
import java.io.*;

/**
 * Mail client main class.
 * Must connect to ports 25/110 for SMTP/POP3 operations.
 * @author George Denchev
 * @version 1.21
 *
 */
public class Client {
	/**
   * @param args main method command-line arguments
   */
  public static void main(String args[]) {
		Socket client= null;
		BufferedReader in= null;
		PrintWriter out= null;
		int port= 0;

		try {
		  in= new BufferedReader(new InputStreamReader(System.in));
			do {
			  System.out.print("Please enter port(25=SMTP, 110=POP3): ");
			  String portStr= in.readLine();
			  try {
				  port= Integer.parseInt(portStr);
					if ((port== 25) || (port== 110))
						break;
			  }
			  catch (NumberFormatException nfe) {
				  System.out.println("Invalid port number!\n");
			  }
			} while ((port!= 25) && (port!= 110));
		  client= new Socket("localhost", port);
			ClientThread clientIO= new ClientThread(client);
			clientIO.setDaemon(true);
			clientIO.start();
			out= new PrintWriter(new OutputStreamWriter(client.getOutputStream()), true);
			while (true) {
				String command= in.readLine();
				if (null== command) {
					System.out.println("Client: Error(Server Down?)!");
					System.exit(-1);
				}
				if (!(command.equals("")))
				  out.println(command);
			}
		}
		catch (IOException ioe) {
			System.out.println("Client: IO Error!");
			System.exit(-1);
		}
	}
}