package nakov1_4;

import java.net.*;
import java.io.*;

/**
 * Mail client helper class handling user I/O operations
 * @author George Denchev
 * @version 1.21
 *
 */
public class ClientThread extends Thread {
	BufferedReader in= null;
	private Socket client;

	/**
   * @param aClient client connection socket
   */
  public ClientThread(Socket aClient) {
		this.client= aClient;
		try {
		  in= new BufferedReader(new InputStreamReader(client.getInputStream()));
		}
		catch (IOException ioe) {
			System.out.println("ClientThread: IO Error!");
			System.exit(-1);
		}
	}

	/**
	 *
	 */
  public void run() {
		try {
			while (true) {
				String message= in.readLine();
				if (null== message) {
					System.out.println("ClientThread: Error(Server Down?)!");
					System.exit(-1);
				}
				System.out.println("Server: "+ message);
				if ((message.equals("221 Bye")) || (message.equals("+OK Bye")))
					System.exit(0);
			}
		}
		catch (IOException ioe) {
			System.out.println("ClientThread: IO Error!");
			System.exit(-1);
		}
	}
}