package nakov1_4;

import java.net.*;
import java.util.*;
import java.io.*;

/**
 * Listens for incoming POP3 connections on port 110.
 * Launches POP3 helper threads to handle POP3 commands/operations.
 * @author George Denchev
 * @version 1.21
 *
 */
public class POP3Listener extends Thread {
  private ServerSocket pop3= null;
  private final int POP3_PORT= 110;
  private MailServer ref= null;

  /**
   * @param ref reference to the main MailServer thread
   */
  public POP3Listener(MailServer ref) {
		this.ref= ref;
		try {
			pop3= new ServerSocket(POP3_PORT);
		}
		catch (IOException ioe) {
			System.out.println("POP3Listener: Cannot Start POP3 Listener(Port "+ POP3_PORT+ ")!");
			System.exit(-1);
		}
	}

  /**
	 *
	 */
  public void run() {
		while (true) {
			try {
				Socket aClient= pop3.accept();
				POP3Thread newPOP3User= new POP3Thread(aClient, ref);
				newPOP3User.setDaemon(false);
				newPOP3User.start();
			}
			catch (IOException ioe) {
				System.out.println("POP3Listener: Error Accepting User!");
			}
		}
	}
}