package nakov1_4;


import java.net.*;
import java.util.*;
import java.io.*;

/**
 * Listens for incoming SMTP connections on port 25.
 * Launches SMTP helper threads to handle SMTP commands/operations.
 * @author George Denchev
 * @version 1.21
 *
 */
public class SMTPListener extends Thread {
  private ServerSocket smtp= null;
  private final int SMTP_PORT= 25;
  private MailServer ref= null;

  /**
   * @param ref reference to the main MailServer thread
   */
  public SMTPListener(MailServer ref) {
		this.ref= ref;
		try {
			smtp= new ServerSocket(SMTP_PORT);
		}
		catch (IOException ioe) {
			System.out.println("SMTPListener: Cannot Start SMTP Listener(Port "+ SMTP_PORT+ ")!");
			System.exit(-1);
		}
  }

  /**
	 *
	 */
  public void run() {
		while (true) {
			try {
				Socket aClient= smtp.accept();
				SMTPThread newSMTPUser= new SMTPThread(aClient, ref);
				newSMTPUser.setDaemon(false);
				newSMTPUser.start();
			}
			catch (IOException ioe) {
				System.out.println("SMTPListener: Error Accepting Client!");
			}
		}
  }
}