

package fmi.ipj.proxy;


import java.io.File;
import java.util.Properties;
import java.io.InputStream;
import java.util.Hashtable;
import java.util.Enumeration;
import java.util.StringTokenizer;
import java.io.FileInputStream;


public class Configuration
{
	private static final String PATH_TO_CONFIG_FILE = "LANProxy.conf";
	
	private static final Properties aProp 			= new Properties();
	private static final Hashtable aHash			= new Hashtable();
	
	public static String aLANProxyIP				= null;
	public static int aLANProxyPort					= -1;
	
	static
	{
		loadConfig();
		storeConfigInHash();
	}
	
	
	private static void loadConfig()
	{
		File lConfFile 	= new File( PATH_TO_CONFIG_FILE );
		
		if( lConfFile.exists() )
		{
			try
			{
				InputStream lFileIS = new FileInputStream( PATH_TO_CONFIG_FILE );
				aProp.load( lFileIS );
			}
			catch( java.io.IOException ioe )
			{
				//do nothing
				ioe.printStackTrace();
			}
		}
		else
		{
			System.out.println("PATH=" + lConfFile.getAbsolutePath() );
		}
	}
	
	
	private static void storeConfigInHash()
	{
		Enumeration lKeys = aProp.keys();
		
		while ( lKeys.hasMoreElements() )
		{
			String lTempKey 	= ( String ) lKeys.nextElement();
			String lTempValue 	= aProp.getProperty( lTempKey );

			if ( lTempKey.equals( "LANProxy" ) )
			{
				StringTokenizer lST = new StringTokenizer( lTempValue, "," );
				int lCountToken = lST.countTokens();
				if ( lCountToken == 2 )
				{
					String loProxyIP 		= ( String ) lST.nextElement();
					String loProxyPort 		= ( String ) lST.nextElement();
					
					try
					{
						aLANProxyPort	 	= Integer.parseInt( loProxyPort );
						aLANProxyIP 		= loProxyIP;
						
						aHash.put( lTempKey, lTempValue );
					}
					catch( NumberFormatException nfe )
					{
						//do nothing
						nfe.printStackTrace();
					}								
					continue;
				}
			}
			
			aHash.put( lTempKey, lTempValue );
		}
	}
}
