

package fmi.ipj.proxy.connector;


import java.net.Socket;
import java.net.InetAddress;

import java.io.InputStream;
import java.io.OutputStream;

import fmi.ipj.proxy.constants.Constants;
import fmi.ipj.proxy.request.HTTPRequest;

import fmi.ipj.proxy.Configuration;


public class RemoteHostConnector
{
	private StreamInitializer aoStreamInitializer	= null;
	
	private Socket aoSocket							= null;
	private InputStream aoInputStream				= null;
	private OutputStream aoOutputStream				= null;
	
	private String aoRemoteHostName					= null;
	private String aoRemoteHostIP					= null;
	private String aoRemoteHostPort					= null;
	
		
	public RemoteHostConnector( HTTPRequest poRequest ) throws fmi.ipj.proxy.connector.ConnectionFailedException
	{
		String lHost;
		int lPort;
	
		if ( Configuration.aLANProxyIP != null )
		{
			lHost 	= Configuration.aLANProxyIP;
			lPort 	= Configuration.aLANProxyPort;
		}
		else
		{
			lHost 	= poRequest.getHost();
			lPort	= poRequest.getPortInt();
		}
				
		aoRemoteHostName = lHost;
		aoRemoteHostPort = Constants.EMPTY_VALUE + lPort;
		
		try
		{
			aoSocket = new Socket( lHost, lPort );
		}
		catch( java.net.UnknownHostException uhe )
		{
			throw new ConnectionFailedException( this, Constants.UNREPORTED_HOST );
		}
		catch( java.io.IOException ioe )
		{
			throw new ConnectionFailedException( this, Constants.CONNECTION_TO_HOST_LOST );
		}
		
		aoStreamInitializer = new StreamInitializer( aoSocket );
		
		aoInputStream 		= aoStreamInitializer.getInputStream();
		aoOutputStream 		= aoStreamInitializer.getOutputStream();
		aoRemoteHostName 	= aoStreamInitializer.getHostName();
		aoRemoteHostIP 		= aoStreamInitializer.getHostIP();
		aoRemoteHostPort 	= aoStreamInitializer.getHostPort();
	}
	
	
	public Socket getRemoteServerSocket()
	{
		return aoSocket;
	}
	
	
	public InputStream getInputStreamFromRemoteHost()
	{
		return aoInputStream;
	}
	
	
	public OutputStream getOutputStreamToRemoteHost()
	{
		return aoOutputStream;
	}
	
	
	public String getRemoteHostName()
	{
		return aoRemoteHostName;
	}
	

	public String getRemoteHostIP()
	{
		return aoRemoteHostIP;
	}
	
	
	public String getRemoteHostPort()
	{
		return aoRemoteHostPort;
	}
}
