

package fmi.ipj.proxy.connector;


import java.net.Socket;
import java.net.InetAddress;

import java.io.InputStream;
import java.io.OutputStream;

import fmi.ipj.proxy.constants.Constants;


public class StreamInitializer
{
	private Socket aoSocket						= null;
	private InputStream aoInputStream 			= null;
	private OutputStream aoOutputStream 		= null;
	
	private String aoRemoteHostName				= null;
	private String aoRemoteHostIP				= null;
	private String aoRemoteHostPort				= null;

	public StreamInitializer( Socket poSocket ) throws fmi.ipj.proxy.connector.ConnectionFailedException
	{
		aoSocket 					= poSocket;
		InetAddress lInetAddress 	= poSocket.getInetAddress();
		aoRemoteHostIP 				= lInetAddress.getHostAddress();
		aoRemoteHostName			= lInetAddress.getHostName();
		aoRemoteHostPort			= Constants.EMPTY_VALUE + poSocket.getPort();
		
		try
		{
			aoInputStream 				= poSocket.getInputStream();
			aoOutputStream 				= poSocket.getOutputStream();
		}
		catch( java.io.IOException ioe )
		{
			throw new ConnectionFailedException( this, Constants.CONNECTION_TO_HOST_LOST );
		}	
	}

	
	public InputStream getInputStream()
	{
		return aoInputStream;
	}
	
	
	public OutputStream getOutputStream()
	{
		return aoOutputStream;
	}
	
	
	public String getHostName()
	{
		return aoRemoteHostName;
	}
	

	public String getHostIP()
	{
		return aoRemoteHostIP;
	}
	
	
	public String getHostPort()
	{
		return aoRemoteHostPort;
	}
}
