

package fmi.ipj.proxy.constants;


public class Constants
{
	//Message for Exceptions start
	public static final String CLASS_LABLE						= " CLASS";
	public static final String HASHCODE_LABLE					= " HASHCODE";
	public static final String MESSAGE_LABLE					= " MESSAGE";
	//Message for Exceptions end
	
	//Message for HTTPRequestParser start
	public static final String SPACE_NOT_FOUND		 			= "Space not found after query name!";
	public static final String STREAM_CLOSED 					= "Stream closed while receiveing the empty line!";
	public static final String IO_ERROR				 			= "I/O error while parsing HTTP request!";
	public static final String PROTOCOL_NOT_FOUND				= "Protocol not found in the and of query!";
	public static final String VERSION_NOT_FOUND				= "Protocol version not found!";
	public static final String WRONG_FORMAT_FOR_KEY_VALUE		= "Wrong format for key:value couple parameter!";
	public static final String BAD_PORT							= "Bad port! Port must be integer number!";
	public static final String REQUEST_NAME_NOT_ALLOWED			= "Query name not allowed!";
	//Message for HTTPRequestParser end
	
	//Message for HTTPResponseCreate start
	public static final String DOMAIN_IS_RESTRICTED_CODE		= "401";
	public static final String DOMAIN_IS_RESTRICTED_MESSAGE		= "Unauthorized";	
	public static final String DOMAIN_IS_RESTRICTED_DATA		= "Access to domain is restricted. Contact your system administrator for more information.";
	public static final String PAGE_NOT_FOUND_CODE				= "404";
	public static final String PAGE_NOT_FOUND_MESSAGE			= "Not Found";
	public static final String PAGE_NOT_FOUND_DATA				= "The page couldn't be found.";
	public static final String BAD_REQUEST_FROM_CLIENT_CODE		= "400";
	public static final String BAD_REQUEST_FROM_CLIENT_MESSAGE	= "Bed Request";
	public static final String BAD_REQUEST_FROM_CLIENT_DATA		= "Bed HTTP request.";
	public static final String NOT_IMPLEMENTED_CODE				= "501";
	public static final String NOT_IMPLEMENTED_MESSAGE			= "Not Implemented";
	public static final String NOT_IMPLEMENTED_DATA				= "Not Implemented.";
	public static final String UNKNOWN_ERROR_CODE				= "1001";
	public static final String UNKNOWN_ERROR_MESSAGE			= "Unknown Error";
	public static final String UNKNOWN_ERROR_DATA				= "Unknown Error.";	
	//Message for HTTPResponseCreate end

	//Message for HTTPRequestValidater end		
	public static final String UNSUPPORTED_QUERY_NAME			= "Query name not supported!";
	public static final String HOST_SUFFIX_NOT_ALLOWED			= "Host suffix not allowed!";
	//Message for HTTPRequestValidater end

	//Message for connector package start
	public static final String UNREPORTED_HOST					= "Unreported host!";
	public static final String CONNECTION_TO_HOST_LOST			= "Connection to host lost!";
	//Message for connector package end
		
	//Message for HTTPProxyThread start
	public static final String CLIENT							= " Client:";
	public static final String SERVER							= " Server:";
	public static final String PROCESS_ID						= " Process ID:";
	public static final String REQUEST_READ_FROM_CLIENT			= " Request read from client:";
	public static final String REQUEST_SEND_TO_SERVER			= " Request send to server:";
	public static final String RESPONSE_READ_FROM_SERVER		= " Read from server:";
	public static final String RESPONSE_SEND_TO_CLIENT			= " Send to client:";
	public static final String OK								= " OK!";
	//Message for HTTPProxyThread end

	public static final String EMPTY_VALUE 						= "";
	public static final String PROTOCOL_SUFFIX 					= "://";	
	public static final String HOST_PORT_SEPARATER 				= ":";
	public static final String HOST_SUFFIX 						= "/";
	public static final String PATH_SEPARATER					= "/";
	public static final String PROTOCOL_VERSION_SEPARATER 		= "/";
	public static final String KEY_VALUE_SEPARATER		 		= ":";
	public static final char   PATH_SEPARATER_CHAR				= '/';
	
	public static final String DEFAULT_PROTOCOL					= "HTTP";
	public static final String DEFAULT_PROTOCOL_VERSION			= "1.0";
	public static final String DEFAULT_HOST						= "localhost";
	public static final String DEFAULT_PORT						= "80";
	public static final int DEFAULT_PORT_INT 					= 80;
	public static final String DEFAULT_PATH						= "";
	public static final String SPACE							= " ";
	public static final String HOST_KEY							= "Host";
	public static final char CARRIAGE_RETURN				 	= '\r';
	public static final char NEW_LINE_CHAR						= '\n';	
	public static final String NEW_LINE							= EMPTY_VALUE + CARRIAGE_RETURN + NEW_LINE_CHAR;

	public static final String DEFAULT_RESPONSE_CODE 			= "200";
	public static final String DEFAULT_MESSAGE 					= "OK";
	public static final String MIME_VERSION_KEY					= "MIME-Version";
	public static final String MIME_VERSION_VALUE				= "1.0";	
	public static final String CONTENT_TYPE_KEY					= "Content-type";
	public static final String CONTENT_TYPE_VALUE				= "text/html";	
	public static final String HTML_START_TAG 					= "<html>";
	public static final String HTML_END_TAG 					= "</html>";
	public static final String MESSAGE_START_TAG				= "<H1><p align=\"center\">";
	public static final String MESSAGE_END_TAG 					= "</p></H1>";

	public static final String OPEN_BRACKET						= "(";
	public static final String CLOSE_BRACKET					= ")";	
		
	public static final String GET_REQUEST_NAME					= "get";
	public static final String POST_REQUEST_NAME				= "post";
	public static final String HEAD_REQUEST_NAME				= "head";

	public static final int aBufferSize							= 4096; //4K - standart size of stream buffer
	
	public static final String NOT_ALLOWED_HOST_SUFFIX[]		= { ".bg"
														  		  };
																  
																  
	public static synchronized boolean isRequestAllowed( String poRequest )
	{
		boolean lResult = false;
		
		if ( GET_REQUEST_NAME.toUpperCase().equals( poRequest ) )
		{
			lResult = true;
		}
		
		if ( POST_REQUEST_NAME.toUpperCase().equals( poRequest ) )
		{
			lResult = true;
		}

		if ( HEAD_REQUEST_NAME.toUpperCase().equals( poRequest ) )
		{
			lResult = true;
		}
		
		return lResult;
	}

	
	public static synchronized boolean isHostAllowed( String poHost )
	{
		boolean lResult = true;
		
		if ( poHost == null )
		{
			lResult = false;
		}
		else
		{
			for ( int i = 0; i < NOT_ALLOWED_HOST_SUFFIX.length; i++ )
			{
				if ( poHost.endsWith( NOT_ALLOWED_HOST_SUFFIX[i] ) || poHost.endsWith( NOT_ALLOWED_HOST_SUFFIX[i].toUpperCase() ) )
				{
					lResult = false;
					i 		= NOT_ALLOWED_HOST_SUFFIX.length;	//Break is unwanted and
					continue;									//it is  replaced.:-)
				}
			}
		}
		
		return lResult;
	}
}
