

package fmi.ipj.proxy.request;


import java.util.Hashtable;
import java.util.Enumeration;

import fmi.ipj.proxy.constants.Constants;
import fmi.ipj.proxy.log.Log;

public class HTTPRequest
{
	private String aoRequestName			= null;
	private String aoProtocolFromURL		= Constants.DEFAULT_PROTOCOL;
	private String aoProtocol 				= Constants.DEFAULT_PROTOCOL;
	private String aoProtocolVersion	 	= Constants.DEFAULT_PROTOCOL_VERSION;
	private String aoHost 					= Constants.DEFAULT_HOST;
	private String aoPort 					= Constants.DEFAULT_PORT;
	private int aPortInt					= Constants.DEFAULT_PORT_INT;
	private String aoPath 					= Constants.DEFAULT_PATH;

	public boolean aIsProtocolFromURLSet	= false;	
	public boolean aIsProtocolSet			= false;
	public boolean aIsProtocolVersionSet	= false;
	public boolean aIsHostSet				= false;
	public boolean aIsPortSet				= false;
	public boolean aIsPathSet				= false;
						
	private Hashtable aoProperties 		= new Hashtable();

	
	public HTTPRequest()
	{
		init();
	}
	
	
	private void init()
	{
		addProperty( Constants.MIME_VERSION_KEY, Constants.MIME_VERSION_VALUE );
		addProperty( Constants.CONTENT_TYPE_KEY, Constants.CONTENT_TYPE_VALUE );		
	}
	
	
	public void setRequestName( String poRequestName )
	{
		aoRequestName = poRequestName;
	}
	
	
	public String getRequestName()
	{
		return aoRequestName;
	}
	
	
	public String getProtocolFromURL()
	{
		return this.aoProtocolFromURL;
	}


	public void setProtocolFromURL( String poProtocolFromURL )
	{
		aoProtocolFromURL 		= poProtocolFromURL;
		aIsProtocolFromURLSet 	= true;
	}

	
	public String getProtocol()
	{
		return aoProtocol;
	}


	public void setProtocol( String poProtocol )
	{
		aoProtocol 		= poProtocol;
		aIsProtocolSet 	= true;
	}

	
	public String getHost()
	{
		return aoHost;
	}


	public void setHost(String poHost)
	{
		aoHost 		= poHost;
		aIsHostSet 	= true;
	}


	public String getProtocolVersion()
	{
		return aoProtocolVersion;
	}


	public void setProtocolVersion( String poProtocolVersion )
	{
		aoProtocolVersion 		= poProtocolVersion;
		aIsProtocolVersionSet 	= true;
	}

	
	public String getPort()
	{
		return aoPort;
	}


	public void setPort( String poPort )
	{
		aoPort 		= poPort;
		aIsPortSet	= true;
	}


	public int getPortInt()
	{
		return aPortInt;
	}


	public void setPortInt( int pPort )
	{
		aPortInt	= pPort;
		aIsPortSet	= true;
	}

	
	public String getPath()
	{
		return aoPath;
	}


	public void setPath( String poPath )
	{
		aoPath 		= poPath;
		aIsPathSet 	= true;
	}
	
	
	public void addProperty( String poKey, String poValue )
	{
		aoProperties.put( poKey, poValue );
	}

	
	public String toString()
	{
		String loString = Constants.EMPTY_VALUE;
		loString += aoRequestName + Constants.SPACE;
		loString += aoProtocolFromURL + Constants.PROTOCOL_SUFFIX;
		loString += aoHost + Constants.HOST_PORT_SEPARATER + aoPort;
		loString += Constants.HOST_SUFFIX;
		loString += aoPath + Constants.SPACE;
		loString += aoProtocol + Constants.PROTOCOL_VERSION_SEPARATER + aoProtocolVersion;
		loString += Constants.NEW_LINE;
		
		Enumeration lEnum = aoProperties.keys();
		while ( lEnum.hasMoreElements() )
		{
			String lTempKey 	= ( String )lEnum.nextElement();
			String lTempValue 	= ( String )aoProperties.get( lTempKey );
			
			loString += lTempKey + Constants.KEY_VALUE_SEPARATER + Constants.SPACE + lTempValue;
			loString += Constants.NEW_LINE;			
		}
		loString += Constants.NEW_LINE;
		
		return loString;
	}


//	public String info()
//	{
//		String loString  = "Protocol=" + aoProtocol + " isSet=" + aIsProtocolSet + ",  ";
//		loString 		+= "ProtocolVersion=" + aoProtocolVersion + " isSet=" + aIsProtocolVersionSet + ",  ";
//		loString 		+= "Host=" + aoHost + " isSet=" + aIsHostSet + ",  ";
//		loString 		+= "Port=" + aoPort + " isSet=" + aIsPortSet + ",  ";
//		loString 		+= "Path=" + aoPath + " isSet=" + aIsPathSet;
//		
//		return loString;
//	}	
}
