

package fmi.ipj.proxy.response;


import fmi.ipj.proxy.constants.Constants;


public class HTTPResponseCreater
{
	public String createResponseForError( Exception e )
	{
		HTTPResponse loHTTPResponse = new HTTPResponse();
		String loExceptionMessage 	= e.toString();
		String loResponseData 		= Constants.EMPTY_VALUE;
		
		if ( loExceptionMessage.endsWith( Constants.SPACE_NOT_FOUND ) )
		{
			createData( loHTTPResponse, Constants.BAD_REQUEST_FROM_CLIENT_CODE, Constants.BAD_REQUEST_FROM_CLIENT_MESSAGE, Constants.BAD_REQUEST_FROM_CLIENT_DATA );
		}
		else if ( loExceptionMessage.endsWith( Constants.STREAM_CLOSED ) )
		{
			createData( loHTTPResponse, Constants.PAGE_NOT_FOUND_CODE, Constants.PAGE_NOT_FOUND_MESSAGE, Constants.PAGE_NOT_FOUND_DATA );
		}
		else if ( loExceptionMessage.endsWith( Constants.IO_ERROR ) )
		{
			createData( loHTTPResponse, Constants.PAGE_NOT_FOUND_CODE, Constants.PAGE_NOT_FOUND_MESSAGE, Constants.PAGE_NOT_FOUND_DATA );
		}
		else if ( loExceptionMessage.endsWith( Constants.PROTOCOL_NOT_FOUND ) )
		{
			createData( loHTTPResponse, Constants.BAD_REQUEST_FROM_CLIENT_CODE, Constants.BAD_REQUEST_FROM_CLIENT_MESSAGE, Constants.BAD_REQUEST_FROM_CLIENT_DATA );
		}
		else if ( loExceptionMessage.endsWith( Constants.VERSION_NOT_FOUND ) )
		{
			createData( loHTTPResponse, Constants.BAD_REQUEST_FROM_CLIENT_CODE, Constants.BAD_REQUEST_FROM_CLIENT_MESSAGE, Constants.BAD_REQUEST_FROM_CLIENT_DATA );
		}
		else if ( loExceptionMessage.endsWith( Constants.WRONG_FORMAT_FOR_KEY_VALUE ) )
		{
			createData( loHTTPResponse, Constants.BAD_REQUEST_FROM_CLIENT_CODE, Constants.BAD_REQUEST_FROM_CLIENT_MESSAGE, Constants.BAD_REQUEST_FROM_CLIENT_DATA );
		}
		else if ( loExceptionMessage.endsWith( Constants.BAD_PORT ) )
		{
			createData( loHTTPResponse, Constants.BAD_REQUEST_FROM_CLIENT_CODE, Constants.BAD_REQUEST_FROM_CLIENT_MESSAGE, Constants.BAD_REQUEST_FROM_CLIENT_DATA );
		}
		else if ( loExceptionMessage.endsWith( Constants.REQUEST_NAME_NOT_ALLOWED ) )
		{
			createData( loHTTPResponse, Constants.BAD_REQUEST_FROM_CLIENT_CODE, Constants.BAD_REQUEST_FROM_CLIENT_MESSAGE, Constants.BAD_REQUEST_FROM_CLIENT_DATA );
		}
		else if ( loExceptionMessage.endsWith( Constants.UNSUPPORTED_QUERY_NAME ) )
		{
			createData( loHTTPResponse, Constants.NOT_IMPLEMENTED_CODE, Constants.NOT_IMPLEMENTED_MESSAGE, Constants.NOT_IMPLEMENTED_DATA );
		}
		else if ( loExceptionMessage.endsWith( Constants.HOST_SUFFIX_NOT_ALLOWED ) )
		{
			createData( loHTTPResponse, Constants.DOMAIN_IS_RESTRICTED_CODE, Constants.DOMAIN_IS_RESTRICTED_MESSAGE, Constants.DOMAIN_IS_RESTRICTED_DATA );
		}
		else if ( loExceptionMessage.endsWith( Constants.UNREPORTED_HOST ) )
		{
			createData( loHTTPResponse, Constants.PAGE_NOT_FOUND_CODE, Constants.PAGE_NOT_FOUND_MESSAGE, Constants.PAGE_NOT_FOUND_DATA );
		}
		else if ( loExceptionMessage.endsWith( Constants.CONNECTION_TO_HOST_LOST ) )
		{
			createData( loHTTPResponse, Constants.PAGE_NOT_FOUND_CODE, Constants.PAGE_NOT_FOUND_MESSAGE, Constants.PAGE_NOT_FOUND_DATA );
		}
		else
		{
			createData( loHTTPResponse, Constants.UNKNOWN_ERROR_CODE, Constants.UNKNOWN_ERROR_MESSAGE, Constants.UNKNOWN_ERROR_DATA );
		}
		
		return loHTTPResponse.toString();
	}
	
	
	private void createData( HTTPResponse loHTTPResponse, String loErrorCode, String loErrorMessage, String loData )
	{
		String loResult = Constants.HTML_START_TAG + Constants.NEW_LINE
						+ Constants.SPACE + Constants.MESSAGE_START_TAG + Constants.NEW_LINE
						+ Constants.SPACE + Constants.SPACE + loData + Constants.NEW_LINE
						+ Constants.SPACE + Constants.MESSAGE_END_TAG + Constants.NEW_LINE
						+ Constants.HTML_END_TAG + Constants.NEW_LINE;

		loHTTPResponse.setCode( loErrorCode );
		loHTTPResponse.setMessage( loErrorMessage );
		loHTTPResponse.setData( loResult );
	}
}
