/*
	UDP Chat Server
	Internet Programming with Java Course
	
	(c) 2002 Martin Valkanov

	ClientInfo is used for addressing a client via InetAddress and a Port.
	Messages are send through the ClientServer attached to the ClientInfo.	
*/

import java.net.InetAddress;
import java.net.UnknownHostException;
import java.util.StringTokenizer;

public class ClientInfo
{
	public String mId;
	public InetAddress mAddr;
	public int mPort;
	public ClientSender mSender;
	
	ClientInfo( String id ) throws UnknownHostException
	{
		mId = id;
		
		StringTokenizer strTok = new StringTokenizer( mId, ":", false );
		
		mAddr = InetAddress.getByName( strTok.nextToken() );
		mPort = Integer.parseInt( strTok.nextToken() );
	}
	
	public boolean equals( Object o )
	{
		return mId.equals(o);
	}
};