
import java.net.Socket;
import java.net.InetAddress;
import java.net.UnknownHostException;
import java.io.*;
import java.util.StringTokenizer;
import java.util.NoSuchElementException;
import java.util.Date;
import java.text.DateFormat;

/*
 * User: mike
 * Date: Mar 24, 2002
 * Time: 3:36:00 PM
 *
 *
 */

public class ServerThread extends Thread {
    private static final String nl  = System.getProperty("line.separator");
    private String rootDir          = "C:/temp";

    private Socket socket           = null;
    private BufferedReader  in      = null;
    private PrintWriter     out     = null;
    private OutputStream bynaryOut  = null;

    private String  contentType = "text/html";
    private String  httpVer     = "1.0";
    private int     responseCode= 200           ;
/**
 * variable file is absolut name of file,
 * variable fileName is only the real name of file
 */
    private void createHtmlListOfFiles(String fileName, File file)
    {
        System.out.println("Requated file is: " + file.getName());
        String  host        = null;
        String[] fileList   = null;

        String  slash       = "/";
        String  img			= "unknown.gif";
        String  size        = "-";
        String  modified    = "";
        String  indexOf     = "Index of " + fileName;
        File    checkFile   = null;

        if(!fileName.endsWith("/")) {
            fileName += "/" ;
        }

        fileName    = strReplace(fileName, " ", "%20"); // URL encoding of spaces
        host        = socket.getLocalAddress().getHostAddress();

        out.print(genHttpHeader(200,"text/html"));
                out.print("<HTML> <HEAD>  <TITLE>"
                         + indexOf
                         + "</TITLE> </HEAD> <BODY><H1>"
                         + indexOf
                         + "</H1>");

        fileList     = file.list();

        String  absPath     = null;;
        String  parentName  = "";
        checkFile   = file.getParentFile();
        absPath     = checkFile.getAbsolutePath();
        try {
            parentName  = absPath.substring(rootDir.length() + 1) + "/";
        } catch (Exception e) {
        }
        modified    = DateFormat.getDateTimeInstance().format(new Date(checkFile.lastModified()));

        out.println("<TABLE><TR><TD></TD><TD>Name</TD><TD>Modified</TD><TD>Size</TD></TR>");
        out.print("<TR><TD  colspan=\"4\"><HR></TD></TR>");
        out.println("<TR><TD><IMG src=\"/icons/back.gif\"></TD><TD><A HREF=\"http://"
                                       + host //+ ":" + PORT
                                       + "/"
                                       + parentName
                                       + "\">"
                                       + "Parent Directory/"
                                       + "</A></TD><TD>"
                                       + modified
                                       + "</TD><TD>"
                                       + size
                                       + "</TD>"
                                       + "</TR>"
                            );

        for (int i = 0; i < fileList.length; i++) {
            checkFile   =   new File(file, fileList[i]);
            modified    = DateFormat.getDateTimeInstance().format(new Date(checkFile.lastModified()));
            if(checkFile.isFile()) {
                            img		= "f.gif";
                            slash   = ""; //if it is file, there shouldn't be slash after filename
                            size    = "" + checkFile.length();
            } else {
				img		= "folder.gif";
                slash   = "/";
                size    = "-";
            }

            out.println("<TR><TD><IMG src=\"/icons/"
							   + img
							   + "\"></TD><TD><A HREF=\"http://"
                               + host
                               + fileName
                               + fileList[i]
                               + slash
                               + "\">"
                               + fileList[i]
                               + slash
                               + "</A></TD><TD>"
                               + modified
                               + "</TD><TD>"
                               + size
                               + "</TD>"
                               + "</TR>"
            );
        }
        out.println("<TR><TD  colspan=\"4\"><HR><TD></TR></TABLE></BODY></HTML>");

        out.flush();
    }
    /**
     * Generates HTTP header
     */
    private String genHttpHeader(int responseCode, String contentType) {
        return "HTTP/"
                + httpVer
                + " " + responseCode + " OK"
                + nl
                + "MIME-Version: 1.0"
                + nl
                + "Content-type: " + contentType
                + nl + nl;
    }
    /**
     * Sends content of the file to the bynaryOut
     */
    private void sendFile(File file)
    {
        int portion = 2048;
        int readed  = 0;

        long length = file.length();
        byte[] buff = new byte[portion];

        String  fileName    = file.getName();
        fileName = fileName.toLowerCase();

        if(fileName.endsWith(".gif")) {
            contentType = "image/gif";
        } else if(fileName.endsWith(".jpg")) {
            contentType = "image/pjpeg";        //image/jpg,  image/jpeg
        } else if(fileName.endsWith(".htm") || fileName.endsWith(".html")) {
            contentType = "text/html";
        } else {
            contentType = "text/plain";
        }

        out.print(genHttpHeader(200, contentType));
        out.flush();
         try {
            FileInputStream fileStream  = new FileInputStream(file);
            while( (readed = fileStream.read(buff)) != -1) {
            bynaryOut.write(buff, 0, readed);
            }
            bynaryOut.flush();

        } catch (IOException e) {
            e.printStackTrace();
        }

       // out.flush();
    }

    public void run()
    {
        try {
            in          = new BufferedReader(new InputStreamReader(socket.getInputStream()));
            bynaryOut   = socket.getOutputStream();
            out = new PrintWriter(new OutputStreamWriter(bynaryOut));
            String fileName     = null;
            StringTokenizer st  = new StringTokenizer(in.readLine());

            fileName = st.nextToken();
            if(!fileName.equalsIgnoreCase("GET"))
                throw new NoSuchElementException();
            fileName = st.nextToken();
            fileName = optimizeUrl(fileName);
            fileName = strReplace(fileName, "%20", " "); // Replacement of URL encoded space with "normal" space

            if(st.nextToken().toLowerCase().endsWith("1.1")) {
                httpVer = "1.1";
            }

            String absolutePath = rootDir + fileName;
            File file           = new File(absolutePath);
            if(!file.exists()) {
                genHTMLMessage(404,"The requested URL "+ fileName+" was not found", out);
            } else if(!file.canRead()) {
                genHTMLMessage(403,"Forbidden", out);
            } else if(file.isDirectory()) {
                createHtmlListOfFiles(fileName, file);
            } else if(file.isFile()) {
                sendFile(file);
            }

        } catch (IOException ioe) {
            ioe.printStackTrace();
        } catch (NoSuchElementException e) {
            genHTMLMessage(400,"Bad request", out);
        }
        try {
            socket.close();
        } catch (IOException e) {
            e.printStackTrace();
        }

    }

    /**
     *  Generates message as HTML code
     */
    private void genHTMLMessage(int errorCode, String message, PrintWriter output) {
        output.print(genHttpHeader(errorCode, "text/html"));
        output.print("<html>"
                       + message
                       + "</html>");
        output.flush();
    }

    /**
     * Replaces all occurrences of string oldString in input wiht string newString
     */
    private String strReplace(String input, String oldString, String newString) {
        int length = oldString.length();
        if(length == 0)
            return input;

        int index = 0;
        int start = 0;
        StringBuffer output = new StringBuffer();

        while((index = input.indexOf(oldString, start)) != -1) {
            output.append(input.substring(start, index)).append(newString);
            start = index + length;
        }
        output.append(input.substring(start));
        return output.toString();
    }

    /**
     * Returns fileName (url) if the fileName has no more "../" then /XXX ,
     * where XXX is a name of subdirectory, otherwise returns "/"
     */
    private String optimizeUrl(String fileName) {

        int i   = 0, l = fileName.length(), start = 0;
        int position = 0;
        char ch = '1';

        while( (i = fileName.indexOf("/", start))!= -1) {
            if(++i >= l)
                break;
            ch = fileName.charAt(i);
            switch (ch) {
                case '.':
                    position--;
                    break;
                case '/':
                    break;
                default:
                    position++;
            }
            start = i;
            if(position < 0){
                return "/";
            }
        }
        return fileName;
    }

    public ServerThread(Socket socket)
    {
        this.socket =   socket;
        this.start();
    }



}
