package smtp_and_pop3;

/**
 * <p>Title: inet java 1.4</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author Milena Iordanova
 * @version 1.0
 */
import smtp_and_pop3.*;
import java.util.*;

/**
 * Mailbox for a single user
 * <p>Title: inet java 1.4</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author Milena Iordanova
 * @version 1.0
 */
public class MailBox {
  private ArrayList m_alMessages; // Stores String[]

  /**
   * Constructor
   */
  public MailBox() {
    m_alMessages = new ArrayList();
  }

  /**
   * Adds a new message to the mailbox
   * @param message The message to be added
   */
  public synchronized void AddMessage(String[] message) {
    m_alMessages.add(message);
  }

  /**
   * Returns the sizes of the messages currently in the mailbox.
   * This is used for implementing the LIST command.
   * @return List of message sizes
   */
  public synchronized String[] List() {
    ArrayList al = new ArrayList();

    int iNumMessages = m_alMessages.size();
    for(int i = 0; i < iNumMessages; i++) {
      String[] message = (String[])m_alMessages.get(i);
      int iByteCount = 0;
      int iNewLine = 1;
      String strNewLine = System.getProperty("line.separator");

      if(strNewLine != null)
        iNewLine = strNewLine.length();

      for(int j = 0; j < message.length; j++) {
        iByteCount += message[j].length() + iNewLine;
      }

      al.add(Integer.toString(iByteCount));
    }

    String[] strList = new String[al.size()];

    for(int i = 0; i < strList.length; i++)
      strList[i] = (String)al.get(i);

    return strList;
  }

  /**
   * Returns a message
   * @param index The number of the message in the inbox to be retrieved
   * @return The message with number equivalent to index
   */
  public synchronized String[] Retrieve(int index) {
    return (String[])m_alMessages.get(index);
  }

  /**
   * Returns the count of the messages currently in the mailbox
   * @return The count of the messages currently in the mailbox
   */
  public synchronized int GetMessageCount() {
    return m_alMessages.size();
  }
}