/*
 * Created by IntelliJ IDEA.
 * User: peter
 * Date: Apr 19, 2002
 * Time: 3:07:24 PM
 */
package utils;

import java.util.ArrayList;
import java.util.StringTokenizer;
import java.util.Iterator;
import java.util.ListIterator;

public class CommandTokenizer {
	ArrayList tokenList = new ArrayList();
	Iterator iter;
	int position = 0;

	public CommandTokenizer(String command) {
		StringTokenizer tokens = new StringTokenizer(command, " \t", true);
		while (tokens.hasMoreTokens()) {
			String token = tokens.nextToken();
			if (!token.startsWith("\""))
				tokenList.add(token);
			else if (token.endsWith("\""))
				tokenList.add(token.substring(1, token.length()-1));
			else {
				String s = token.substring(1);
				do {
					String next = "";
					if (tokens.hasMoreTokens())
						next = tokens.nextToken();
					else
						break;
					if (next.endsWith("\"")) {
						s = s + next.substring(0, next.length()-1);
						break;
					} else {
						s = s + next;
					}
				} while (true);
				tokenList.add(s);
			}
		}
		ListIterator i = tokenList.listIterator();
		while (i.hasNext()) {
			String t = (String)i.next();
			if (t.equals(" ") || t.equals("\t"))
				i.remove();
		}
		iter = tokenList.iterator();
        position = 0;
	}

	public boolean hasMoreTokens() {
		return (position < tokenList.size());
	}

	public int countTokens() {
		return tokenList.size() - position;
	}

	public String nextToken() throws IllegalArgumentException {
		if (!hasMoreTokens()) throw new IllegalArgumentException();
		position++;
		return (String)iter.next();
	}

    public static void main(String[] args) {
		CommandTokenizer ct = new CommandTokenizer("get \"this long name.txt\" and \"some other\" and more");
		while (ct.hasMoreTokens()) {
			System.out.println(ct.countTokens());
			System.out.println(ct.nextToken());
		}
		System.out.println(ct.countTokens());
    }
}
