package utils;

/*
 * Created by IntelliJ IDEA.
 * User: peter
 * Date: Apr 17, 2002
 * Time: 7:05:33 PM
 */

import java.io.*;

/**
 * This class wraps around an InputStream and provides buffering and a readline method for
 * less communication overhead and easier use.
 */
public class CustomSocketReader {
	private final InputStream in;

	public CustomSocketReader(InputStream inputStream) {
		this.in = new BufferedInputStream(inputStream);
	}

    public int read() throws IOException {
        return in.read() ;
    }

	public int read(byte[] array, int offset, int len) throws IOException {
		return in.read(array, offset, len);
	}

    public String readln() throws IOException {
        StringBuffer stringBuffer = new StringBuffer();
        char c;
        while ((c = (char)in.read()) != '\n') {
            stringBuffer.append(c);
        }
        return stringBuffer.toString() ;
    }
}

