package utils;

/*
 * Created by IntelliJ IDEA.
 * User: peter
 * Date: Apr 18, 2002
 * Time: 10:55:32 AM
 */

import java.io.*;

/**
 * This class wraps around an OutputStream and provides buffering and a printline method for
 * less communication overhead and easier use.
 */
public class CustomSocketWriter {
	OutputStream out;

	public CustomSocketWriter(OutputStream outputStream) {
		out = new BufferedOutputStream(outputStream);
	}

	public void write(int c)
		throws java.io.IOException {
		out.write(c);
	}

	public void write(byte[] array, int offset, int len) throws IOException {
		out.write(array, offset, len);
		out.flush();
	}

	public void println(String s) throws IOException {
		byte[] aByteArray;
		aByteArray = s.getBytes();
		out.write(aByteArray, 0, aByteArray.length);
		out.write('\n');
		out.flush();
	}

	public void flush() throws IOException {
		out.flush();
	}
}
