package utils;

/*
 * Created by IntelliJ IDEA.
 * User: peter
 * Date: Apr 18, 2002
 * Time: 2:52:49 PM
 */

import java.util.*;
import java.io.*;

/**
 * Misc functions used by both the client and the server
 */
public class Util {
	/**
	 * Returs a list of the names of all files and directories in the given directory
	 * @param path It should represent the full name of a directory
	 * @return The list of names
	 */
	public static synchronized List getDirectoryContent(String path) {
		File oFile = new File(path);
		String[] aList = oFile.list();
		return Arrays.asList(aList);
	}

	/**
	 * Given a full directory name, it returns the full name of the parent directory
	 * @param path
	 * @return Parent dir name
	 */
	public static String parentDir(String path) {
		int i;
		for (i = path.length() - 2; i >= 0; i--) {
			if ((path.charAt(i) == File.separatorChar) || path.charAt(i) == '/') break;
		}
		i++;
		path = path.substring(0, i);
		return path;
	}

	/**
	 * Replaces pattern with replace in string str.
	 * Does not change the given arguments, just returns the result.
	 * @param str
	 * @param pattern
	 * @param replace
	 * @return The resulting string
	 */
	public static String replace(String str, String pattern, String replace) {
		int s = 0;
		int e = 0;
		StringBuffer result = new StringBuffer();
		while ((e = str.indexOf(pattern, s)) >= 0) {
			result.append(str.substring(s, e));
			result.append(replace);
			s = e + pattern.length();
		}
		result.append(str.substring(s));
		return result.toString();
	}

}
