package SimpleMailServer;
import java.util.Vector;


/**
  *  Represetnts a single maildrop for a user.
  *  This class contains a Vector of   SMSMessage
  *  objects. Each SMSMessage contains a single
  *  mail message.
  *
  *  @see   SimpleMailServer.SMSMessage
  */
public class SMSMailDrop
{
	/** is mailbox locked for POP3 retrieval */
	private boolean m_locked= false;
      void Lock() { m_locked= true; }
      void UnLock() { m_locked= false; }
      boolean isLocked() {return m_locked; }



      /**
        * array of messages in this INBOX
        *
	  *  @see   SimpleMailServer.SMSMessage        
        */
	Vector m_mail_drop= new Vector();

	public SMSMailDrop() {
	}

      /**
        * add new mail message to the INBOX. It is
        * synchronized with deleteMessage.
        */
      synchronized void addMessage(SMSMessage message)
      {
      	m_mail_drop.addElement(message);
      }

      SMSMessage getMessage(int index)
      {
           if (index<0 || index>m_mail_drop.size())
           	throw new java.lang.IndexOutOfBoundsException();

           return (SMSMessage)m_mail_drop.elementAt(index);
      }

      /**
        * removes message from INBOX of the user. NOT
        * used for now because Nakov dos not requires it
        * and time is short.
        */
      synchronized  void deleteMessage(int index)
      {
           if (index<0 || index>m_mail_drop.size())
           	throw new java.lang.IndexOutOfBoundsException();

           m_mail_drop.removeElementAt(index);
      }

      /**
        * Number of mail messages in this INBOX.
        */
      int getMaildropMessagesNumber()
      { return m_mail_drop.size(); }
}