
//Title:        Simple Mail  Server, 2002, Inet-Java
//Version:      
//Copyright:    Copyright (c) 2002
//Author:       Vasil Karpachev
//Company:      fmi
//Description:  This project is for the Internet Programming in Java,
//for the summer semester of the 2002 year.
//It should implement both POP3 on 110 port
//and SMTP on 25 port with the subset of
//the commands in the above mentioned protocols.
//Its aim is to exercise java.net.* and java.lang.Thread
package SimpleMailServer;
import java.io.*;


/**
  *  Would be responsible for printing conditionaly
  *  to stdout and stderr(in debug version). With
  *  just setting a flag(SMSMain._DEBUG) all output will be
  *  stopped(release version).
  *
  *  It can output to file(s).
  */
class SMSMessageTracer
{
    /**
      *  m_debug == true	- messeges are printed normaly
      *  m_debug == false 	- no messages produced(release
      *				- version of the project)
      */
    private boolean m_debug;
    /** sets/clears the m_debug flag */
    void setDebug(boolean on)
    { m_debug= on; }

    // where the messages go -> screen? file? */
    boolean m_messages_to_screen= true;
    /** for normal output */
    private PrintStream out;
    void setOutputStream(PrintStream o)
    { out= o; m_messages_to_screen= false; }
    /** for error output */
    private PrintStream err;
    void setErrorStream(PrintStream e)
    { err= e; m_messages_to_screen= false; }
    /** Message to print before the actual data */
    private String m_message_prefix;

    void setMessagePrefix(String s)
    { m_message_prefix= s; }
    void addToPrefix(String s)
    { m_message_prefix+= s; }


    /**
      *
      */
    SMSMessageTracer()
    {
    		m_debug= SMSMain._DEBUG;
    		init();
    }

    SMSMessageTracer(String prefix) {
            m_debug= SMSMain._DEBUG;
            m_message_prefix= prefix;
            init();
    }
    private void init()
    {
     		err= System.err;
            out= System.out;
    }


    /**
      *  If debug version prints the prefix and the message
      *  to stdout
      */
    void print(String s)
    {
    	if (m_debug) //only in debug print messages
      {
      	out.print(m_message_prefix+": "+s);
      }
     	if (!m_messages_to_screen) //if not to screen
      	out.println("");
    }

     /**
      *  If debug version prints the message
      *  to stdout
      */
    void pr(String s)
    {
    	if (m_debug) //only in debug print messages
      {
      	if (!m_messages_to_screen) { //if not to screen
            	if (s.length()!=1)
                  	out.print(s);
            } else
            	out.print(s);
      }
    }
    /** prints a random character based on seed */
    void printRandomChar(int seed)
    { pr( (char)(seed%11+33)+"" );  }

    /**
      *  If debug version prints the prefix and the message
      *  to stderr
      */
    void error(String s)
    {
    	if (m_debug) //only in debug print messages
      {
      	err.print(m_message_prefix+": "+s);
      }
     	if (!m_messages_to_screen) //if not to screen
      	err.println("");
    }

    /**
      *  If debug version prints the message
      *  to stderr
      */
    void err(String s)
    {
    	if (m_debug) //only in debug print messages
      {
      	if (!m_messages_to_screen) { //if not to screen
            	if (s.length()!=1)
                       	err.print(s);
            } else // to screen
            	err.print(s);
      }
    }
}