package ftpserver;

/**
 * FTP Server
 * Project 1.5, 'Internet Programming With Java' Cource
 * 
 * @author Vesselin Mitrov, vmitrov@bulgaria.com
 */
 
import java.util.*;
import java.io.*;
import java.net.*;

public class FTPServer {

  public FTPServer() {
    start();
  }
  
  public static void main(String[] args) {
    new FTPServer();
  }
  
  private void start() {
    try {
      Properties props = new Properties();
      props.load(new FileInputStream("server.properties"));
      int portNumber = (new Integer(props.getProperty("port"))).intValue();
      String root = props.getProperty("drive") + ":\\" + props.getProperty("root");
      ServerSocket serverSocket = new ServerSocket(portNumber);
      try {
        while (true) {
          Socket socket = serverSocket.accept();
          (new ServerThread(root, socket)).start();
        }
      } finally {
        serverSocket.close();
      }
    } catch (Exception exc) {
      throw new RuntimeException(exc.toString());
    }
  }
}